function v = inner_dual(u, D, tau, normD, inner_its)
    
p = zeros(size(D,1),1);
step = 1/normD^2;

for i = 1:inner_its
    p = p-step*D*(D'*p-u);
    p(p<-tau) = -tau;
    p(p>tau) = tau;

end

v = u - D'*p;

return
